/*
 * This file is part of the SOAFaces Project (hereinafter "SOAFaces").
 * Copyright (C) 2006 Grand Logic, Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */


package org.soafaces.bundle.client.rpc.impl;

import com.google.gwt.user.client.rpc.RemoteService;
import java.io.Serializable;
import java.util.Map;
import org.soafaces.services.client.rpc.UniversalClientRemoteException;
import org.soafaces.services.client.rpc.GenericDataWrapper;

/**
 *
 * @author Sam Taha
 */
public interface BundleUniversalClientRPC extends RemoteService {
  
  /**
   * 
   * @param endpointURI
   * @param payload
   * @param properties
   * @return
   * @throws org.taskbean.client.MuleClientProcessingException
   */
  GenericDataWrapper sendAnyReturnPOJO(long lJobID, long lTaskID, String endpointURI, GenericDataWrapper payload, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param properties
   * @return
   * @throws org.taskbean.client.MuleClientProcessingException
   */
  GenericDataWrapper sendEmptyReturnPOJO(long lJobID, long lTaskID, String endpointURI, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param payload
   * @param properties
   * @return
   * @throws org.taskbean.client.MuleClientProcessingException
   */
  GenericDataWrapper sendAnyReturnJSON(long lJobID, long lTaskID, String endpointURI, GenericDataWrapper payload, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param properties
   * @return
   * @throws org.taskbean.client.MuleClientProcessingException
   */
  GenericDataWrapper sendEmptyReturnJSON(long lJobID, long lTaskID, String endpointURI, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param payload
   * @param properties
   * @return
   * @throws org.taskbean.client.MuleClientProcessingException
   */
  void dispatchAny(long lJobID, long lTaskID, String endpointURI, GenericDataWrapper payload, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param properties
   * @return
   * @throws org.taskbean.client.MuleClientProcessingException
   */
  void dispatchEmpty(long lJobID, long lTaskID, String endpointURI, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
}
