/*
 * This file is part of the SOAFaces Project (hereinafter "SOAFaces").
 * Copyright (C) 2008 Grand Logic, Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */

package org.soafaces.services.client.rpc;

import com.google.gwt.user.client.rpc.IsSerializable;

/**
 * Internal type used by container to handle JSON marshalling. Not
 * intended for application developer.
 * 
 * @author Sam Taha
 */
final public class JSONTypeWrapper implements IsSerializable {

  private String value = null;
  
  private JSONTypeWrapper() {}
  JSONTypeWrapper(String jsonValue)
  {
    value=jsonValue;
  }
  
  public String getValue() { return value; }
  
}
