/*
 * This file is part of the SOAFaces Project (hereinafter "SOAFaces").
 * Copyright (C) 2006 Grand Logic, Inc.
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations under
 * the License.
 */
package org.soafaces.services.client.rpc;

import com.google.gwt.user.client.rpc.RemoteService;
import java.io.Serializable;
import java.util.Map;

/**
 *
 * @author Sam Taha
 */
public interface UniversalClientRPC extends RemoteService {

  /**
   * 
   * @param endpointURI
   * @param payload
   * @param properties
   * @return
   * @throws UniversalClientRemoteException
   */
  GenericDataWrapper sendAnyReturnPOJO(String endpointURI, GenericDataWrapper payload, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param properties
   * @return
   * @throws org.soafaces.client.rpc.UniversalClientRemoteException
   * 
   */
  GenericDataWrapper sendEmptyReturnPOJO(String endpointURI, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param payload
   * @param properties 
   * @return
   * @throws org.soafaces.client.rpc.UniversalClientRemoteException
   * 
   */
  GenericDataWrapper sendAnyReturnJSON(String endpointURI, GenericDataWrapper payload, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param properties 
   * @return
   * @throws org.soafaces.client.rpc.UniversalClientRemoteException
   * 
   */
  GenericDataWrapper sendEmptyReturnJSON( String endpointURI, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param payload
   * @param properties 
   * @throws org.soafaces.client.rpc.UniversalClientRemoteException
   * 
   */
  void dispatchAny(String endpointURI, GenericDataWrapper payload, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
  /**
   * 
   * @param endpointURI
   * @param properties 
   * @throws org.soafaces.client.rpc.UniversalClientRemoteException
   * 
   */
  void dispatchEmpty(String endpointURI, Map<String, Serializable> properties) throws UniversalClientRemoteException;
  
}
